package Contact::Number;

use strict;
use warnings;

use base 'Contact::GEN::Number';

use Gantry::Plugins::AutoCRUD qw(
    do_add
    do_edit
    do_delete
    form_name
    write_file
);

use Contact::Model::number qw(
    $NUMBER
);

#-----------------------------------------------------------------
# $self->do_main(  )
#-----------------------------------------------------------------
# This method inherited from Contact::GEN::Number

#-----------------------------------------------------------------
# $self->form( $row )
#-----------------------------------------------------------------
# This method inherited from Contact::GEN::Number

#-----------------------------------------------------------------
# $self->do_csv( $id )
#-----------------------------------------------------------------
sub do_csv {
    my ( $self, $id ) = @_;
} # END do_csv

#-----------------------------------------------------------------
# get_model_name( )
#-----------------------------------------------------------------
sub get_model_name {
    return $NUMBER;
}

#-----------------------------------------------------------------
# get_orm_helper( )
#-----------------------------------------------------------------
sub get_orm_helper {
    return 'Gantry::Plugins::AutoCRUDHelper::DBIxClass';
}

#-----------------------------------------------------------------
# text_descr( )
#-----------------------------------------------------------------
sub text_descr     {
    return 'contact number';
}

1;

=head1 NAME

Contact::Number - A controller in the Contact application

=head1 SYNOPSIS

This package is meant to be used in a stand alone server/CGI script or the
Perl block of an httpd.conf file.

Stand Alone Server or CGI script:

    use Contact::Number;

    my $cgi = Gantry::Engine::CGI->new( {
        config => {
            #...
        },
        locations => {
            '/someurl' => 'Contact::Number',
            #...
        },
    } );

httpd.conf:

    <Perl>
        # ...
        use Contact::Number;
    </Perl>

    <Location /someurl>
        SetHandler  perl-script
        PerlHandler Contact::Number
    </Location>

If all went well, one of these was correctly written during app generation.

=head1 DESCRIPTION

This module was originally generated by Bigtop.  But feel free to edit it.
You might even want to describe the table this module controls here.

=head1 METHODS

=over 4

=item do_csv

=item get_model_name

=item text_descr

=item get_orm_helper


=back


=head1 METHODS INHERITED FROM Contact::GEN::Number

=over 4

=item do_main

=item form


=back


=head1 DEPENDENCIES

    Contact
    Contact::GEN::Number
    Contact::Model::number
    Gantry::Plugins::AutoCRUD

=head1 AUTHOR

Phil Crow, E<lt>crow.phil@gmail.comE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2007 Phil Crow

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself, either Perl version 5.8.6 or,
at your option, any later version of Perl 5 you may have available.

=cut
